/*
 * File:          gov_cca_ports_BuilderService_IOR.h
 * Symbol:        gov.cca.ports.BuilderService-v0.7.0
 * Symbol Type:   interface
 * Babel Version: 0.9.3
 * Description:   Intermediate Object Representation for gov.cca.ports.BuilderService
 * 
 * WARNING: Automatically generated; changes will be lost
 * 
 * babel-version = 0.9.3
 */

#ifndef included_gov_cca_ports_BuilderService_IOR_h
#define included_gov_cca_ports_BuilderService_IOR_h

#ifndef included_sidl_header_h
#include "sidl_header.h"
#endif
#ifdef __cplusplus
extern "C" {
#endif

/*
 * Symbol "gov.cca.ports.BuilderService" (version 0.7.0)
 * 
 *    BuilderService is a Port implemented by a CCA compliant framework for
 * the purpose of composing components into applications in a standard way.
 * It is meant to expose the Component creation and composition functionality
 * without the specific framework implementation. This interface is expected 
 * to be useful for rapid application development in a scripting language. 
 * Other uses are generic application development environments for CCA 
 * applications. 
 * <p>Each of the fundamental component architecture pieces
 *    (instances of Component, Port, and Connection) may have
 *    an associated TypeMap of properties managed by the framework.
 *    The standardized keys in the properties of a Port are documented
 *    in Services.getPortProperties().
 *    The standardized keys in the properties of a Component and Connection
 *    are documented below.
 *  </p>
 *  <p>For connection, thus far:
 *    <pre>
 *    Key         value           meaning
 *    cca.isInUse boolean         true if there have been more successful
 * 				 getPort than releasePort calls for the
 * 				 connection at the the time 
 * 				 properties were fetched.
 *   </pre>
 *   </p>
 *  <P>For component, thus far:
 *   <pre>
 *    Key                 value           meaning
 *    cca.className       string          component type
 *   </pre>
 *  </p>
 */

struct gov_cca_ports_BuilderService__array;
struct gov_cca_ports_BuilderService__object;

extern struct gov_cca_ports_BuilderService__object*
gov_cca_ports_BuilderService__remote(const char *url);

/*
 * Forward references for external classes and interfaces.
 */

struct gov_cca_CCAException__array;
struct gov_cca_CCAException__object;
struct gov_cca_ComponentID__array;
struct gov_cca_ComponentID__object;
struct gov_cca_ConnectionID__array;
struct gov_cca_ConnectionID__object;
struct gov_cca_TypeMap__array;
struct gov_cca_TypeMap__object;
struct sidl_BaseException__array;
struct sidl_BaseException__object;
struct sidl_BaseInterface__array;
struct sidl_BaseInterface__object;
struct sidl_ClassInfo__array;
struct sidl_ClassInfo__object;

/*
 * Declare the method entry point vector.
 */

struct gov_cca_ports_BuilderService__epv {
  /* Implicit builtin methods */
  void* (*f__cast)(
    void* self,
    const char* name);
  void (*f__delete)(
    void* self);
  /* Methods introduced in sidl.BaseInterface-v0.9.0 */
  void (*f_addRef)(
    void* self);
  void (*f_deleteRef)(
    void* self);
  sidl_bool (*f_isSame)(
    void* self,
    struct sidl_BaseInterface__object* iobj);
  struct sidl_BaseInterface__object* (*f_queryInt)(
    void* self,
    const char* name);
  sidl_bool (*f_isType)(
    void* self,
    const char* name);
  struct sidl_ClassInfo__object* (*f_getClassInfo)(
    void* self);
  /* Methods introduced in gov.cca.Port-v0.7.0 */
  /* Methods introduced in gov.cca.ports.BuilderService-v0.7.0 */
  struct gov_cca_ComponentID__object* (*f_createInstance)(
    void* self,
    const char* instanceName,
    const char* className,
    struct gov_cca_TypeMap__object* properties,
    struct sidl_BaseInterface__object **_ex);
  struct gov_cca_ComponentID__array* (*f_getComponentIDs)(
    void* self,
    struct sidl_BaseInterface__object **_ex);
  struct gov_cca_TypeMap__object* (*f_getComponentProperties)(
    void* self,
    struct gov_cca_ComponentID__object* cid,
    struct sidl_BaseInterface__object **_ex);
  void (*f_setComponentProperties)(
    void* self,
    struct gov_cca_ComponentID__object* cid,
    struct gov_cca_TypeMap__object* map,
    struct sidl_BaseInterface__object **_ex);
  struct gov_cca_ComponentID__object* (*f_getDeserialization)(
    void* self,
    const char* s,
    struct sidl_BaseInterface__object **_ex);
  struct gov_cca_ComponentID__object* (*f_getComponentID)(
    void* self,
    const char* componentInstanceName,
    struct sidl_BaseInterface__object **_ex);
  void (*f_destroyInstance)(
    void* self,
    struct gov_cca_ComponentID__object* toDie,
    float timeout,
    struct sidl_BaseInterface__object **_ex);
  struct sidl_string__array* (*f_getProvidedPortNames)(
    void* self,
    struct gov_cca_ComponentID__object* cid,
    struct sidl_BaseInterface__object **_ex);
  struct sidl_string__array* (*f_getUsedPortNames)(
    void* self,
    struct gov_cca_ComponentID__object* cid,
    struct sidl_BaseInterface__object **_ex);
  struct gov_cca_TypeMap__object* (*f_getPortProperties)(
    void* self,
    struct gov_cca_ComponentID__object* cid,
    const char* portName,
    struct sidl_BaseInterface__object **_ex);
  void (*f_setPortProperties)(
    void* self,
    struct gov_cca_ComponentID__object* cid,
    const char* portName,
    struct gov_cca_TypeMap__object* map,
    struct sidl_BaseInterface__object **_ex);
  struct gov_cca_ConnectionID__object* (*f_connect)(
    void* self,
    struct gov_cca_ComponentID__object* user,
    const char* usingPortName,
    struct gov_cca_ComponentID__object* provider,
    const char* providingPortName,
    struct sidl_BaseInterface__object **_ex);
  struct gov_cca_ConnectionID__array* (*f_getConnectionIDs)(
    void* self,
    struct gov_cca_ComponentID__array* componentList,
    struct sidl_BaseInterface__object **_ex);
  struct gov_cca_TypeMap__object* (*f_getConnectionProperties)(
    void* self,
    struct gov_cca_ConnectionID__object* connID,
    struct sidl_BaseInterface__object **_ex);
  void (*f_setConnectionProperties)(
    void* self,
    struct gov_cca_ConnectionID__object* connID,
    struct gov_cca_TypeMap__object* map,
    struct sidl_BaseInterface__object **_ex);
  void (*f_disconnect)(
    void* self,
    struct gov_cca_ConnectionID__object* connID,
    float timeout,
    struct sidl_BaseInterface__object **_ex);
  void (*f_disconnectAll)(
    void* self,
    struct gov_cca_ComponentID__object* id1,
    struct gov_cca_ComponentID__object* id2,
    float timeout,
    struct sidl_BaseInterface__object **_ex);
};

/*
 * Define the interface object structure.
 */

struct gov_cca_ports_BuilderService__object {
  struct gov_cca_ports_BuilderService__epv* d_epv;
  void*                                     d_object;
};

#ifdef __cplusplus
}
#endif
#endif
