/*
 * File:          gov_cca_ports_ParameterPortFactory_IOR.h
 * Symbol:        gov.cca.ports.ParameterPortFactory-v0.7.0
 * Symbol Type:   interface
 * Babel Version: 0.9.3
 * Description:   Intermediate Object Representation for gov.cca.ports.ParameterPortFactory
 * 
 * WARNING: Automatically generated; changes will be lost
 * 
 * babel-version = 0.9.3
 */

#ifndef included_gov_cca_ports_ParameterPortFactory_IOR_h
#define included_gov_cca_ports_ParameterPortFactory_IOR_h

#ifndef included_sidl_header_h
#include "sidl_header.h"
#endif
#ifdef __cplusplus
extern "C" {
#endif

/*
 * Symbol "gov.cca.ports.ParameterPortFactory" (version 0.7.0)
 * 
 * This interface supercedes the ccaffeine 
 * ConfigurableParameterPortFactory,
 * the parameters library, and all the associated cruft that
 * gunked up a component. The component writer now just needs to
 * use this port and one or more typemaps.
 * 
 * All the function names and meanings are as identical to
 * the existing ccaffeine interfaces as possible. Most just have
 * a TypeMap argument added and modernized (stl) string usage.
 * Additional functions to support the full generality of TypeMap
 * have been added.
 * 
 * Each ParameterPort is defined on a typemap the component owns.
 * A component writer can define more than one such port for a component,
 * and each will show up as a ParameterPort for UI agents.
 * The component writer can choose to be notified of 
 * parameter reads and writes using the related Listener interfaces.
 * 
 * All strings (help, prompt, value, etc) passed to this 
 * interface must be free
 * of \n and other line-breaking characters if certain
 * ancient gui clients are going to be used. This limitation is
 * in the clients rather than the ParameterPort implementation.
 * Those clients are prone to compressing redundant whitespace 
 * as well. In a rosy future, these client limitations will go away.
 */

struct gov_cca_ports_ParameterPortFactory__array;
struct gov_cca_ports_ParameterPortFactory__object;

extern struct gov_cca_ports_ParameterPortFactory__object*
gov_cca_ports_ParameterPortFactory__remote(const char *url);

/*
 * Forward references for external classes and interfaces.
 */

struct gov_cca_CCAException__array;
struct gov_cca_CCAException__object;
struct gov_cca_Services__array;
struct gov_cca_Services__object;
struct gov_cca_TypeMap__array;
struct gov_cca_TypeMap__object;
struct gov_cca_ports_ParameterGetListener__array;
struct gov_cca_ports_ParameterGetListener__object;
struct gov_cca_ports_ParameterSetListener__array;
struct gov_cca_ports_ParameterSetListener__object;
struct sidl_BaseException__array;
struct sidl_BaseException__object;
struct sidl_BaseInterface__array;
struct sidl_BaseInterface__object;
struct sidl_ClassInfo__array;
struct sidl_ClassInfo__object;

/*
 * Declare the method entry point vector.
 */

struct gov_cca_ports_ParameterPortFactory__epv {
  /* Implicit builtin methods */
  void* (*f__cast)(
    void* self,
    const char* name);
  void (*f__delete)(
    void* self);
  /* Methods introduced in sidl.BaseInterface-v0.9.0 */
  void (*f_addRef)(
    void* self);
  void (*f_deleteRef)(
    void* self);
  sidl_bool (*f_isSame)(
    void* self,
    struct sidl_BaseInterface__object* iobj);
  struct sidl_BaseInterface__object* (*f_queryInt)(
    void* self,
    const char* name);
  sidl_bool (*f_isType)(
    void* self,
    const char* name);
  struct sidl_ClassInfo__object* (*f_getClassInfo)(
    void* self);
  /* Methods introduced in gov.cca.Port-v0.7.0 */
  /* Methods introduced in gov.cca.ports.ParameterPortFactory-v0.7.0 */
  void (*f_initParameterData)(
    void* self,
    struct gov_cca_TypeMap__object** portData,
    const char* portName);
  void (*f_setBatchTitle)(
    void* self,
    struct gov_cca_TypeMap__object* portData,
    const char* title);
  void (*f_setGroupName)(
    void* self,
    struct gov_cca_TypeMap__object* portData,
    const char* newGroupName);
  void (*f_setGroupNameAndTitle)(
    void* self,
    struct gov_cca_TypeMap__object* portData,
    const char* newGroupName,
    const char* groupTitle);
  void (*f_addRequestBoolean)(
    void* self,
    struct gov_cca_TypeMap__object* portData,
    const char* name,
    const char* help,
    const char* prompt,
    sidl_bool bdefault,
    struct sidl_BaseInterface__object **_ex);
  void (*f_addRequestInt)(
    void* self,
    struct gov_cca_TypeMap__object* portData,
    const char* name,
    const char* help,
    const char* prompt,
    int32_t idefault,
    int32_t low,
    int32_t high,
    struct sidl_BaseInterface__object **_ex);
  void (*f_addRequestLong)(
    void* self,
    struct gov_cca_TypeMap__object* portData,
    const char* name,
    const char* help,
    const char* prompt,
    int64_t ldefault,
    int64_t low,
    int64_t high,
    struct sidl_BaseInterface__object **_ex);
  void (*f_addRequestFloat)(
    void* self,
    struct gov_cca_TypeMap__object* portData,
    const char* name,
    const char* help,
    const char* prompt,
    float fdefault,
    float low,
    float high,
    struct sidl_BaseInterface__object **_ex);
  void (*f_addRequestDouble)(
    void* self,
    struct gov_cca_TypeMap__object* portData,
    const char* name,
    const char* help,
    const char* prompt,
    double ddefault,
    double low,
    double high,
    struct sidl_BaseInterface__object **_ex);
  void (*f_addRequestString)(
    void* self,
    struct gov_cca_TypeMap__object* portData,
    const char* name,
    const char* help,
    const char* prompt,
    const char* sdefault,
    struct sidl_BaseInterface__object **_ex);
  void (*f_addRequestStringChoice)(
    void* self,
    struct gov_cca_TypeMap__object* portData,
    const char* key,
    const char* choice,
    struct sidl_BaseInterface__object **_ex);
  void (*f_addStringChoices)(
    void* self,
    struct gov_cca_TypeMap__object* portData,
    const char* name,
    struct sidl_string__array* choices,
    struct sidl_BaseInterface__object **_ex);
  void (*f_addIntChoices)(
    void* self,
    struct gov_cca_TypeMap__object* portData,
    const char* name,
    struct sidl_int__array* choices,
    struct sidl_BaseInterface__object **_ex);
  void (*f_addLongChoices)(
    void* self,
    struct gov_cca_TypeMap__object* portData,
    const char* name,
    struct sidl_long__array* choices,
    struct sidl_BaseInterface__object **_ex);
  void (*f_addFloatChoices)(
    void* self,
    struct gov_cca_TypeMap__object* portData,
    const char* name,
    struct sidl_float__array* choices,
    struct sidl_BaseInterface__object **_ex);
  void (*f_addDoubleChoices)(
    void* self,
    struct gov_cca_TypeMap__object* portData,
    const char* name,
    struct sidl_double__array* choices,
    struct sidl_BaseInterface__object **_ex);
  void (*f_addFcomplexChoices)(
    void* self,
    struct gov_cca_TypeMap__object* portData,
    const char* name,
    struct sidl_fcomplex__array* choices,
    struct sidl_BaseInterface__object **_ex);
  void (*f_addDcomplexChoices)(
    void* self,
    struct gov_cca_TypeMap__object* portData,
    const char* name,
    struct sidl_dcomplex__array* choices,
    struct sidl_BaseInterface__object **_ex);
  void (*f_clearRequests)(
    void* self,
    struct gov_cca_TypeMap__object* portData);
  void (*f_registerUpdater)(
    void* self,
    struct gov_cca_TypeMap__object* portData,
    struct gov_cca_ports_ParameterGetListener__object* powner);
  void (*f_registerUpdatedListener)(
    void* self,
    struct gov_cca_TypeMap__object* portData,
    struct gov_cca_ports_ParameterSetListener__object* powner);
  void (*f_addParameterPort)(
    void* self,
    struct gov_cca_TypeMap__object* portData,
    struct gov_cca_Services__object* svc);
  void (*f_removeParameterPort)(
    void* self,
    struct gov_cca_TypeMap__object* portData,
    struct gov_cca_Services__object* svc);
};

/*
 * Define the interface object structure.
 */

struct gov_cca_ports_ParameterPortFactory__object {
  struct gov_cca_ports_ParameterPortFactory__epv* d_epv;
  void*                                           d_object;
};

#ifdef __cplusplus
}
#endif
#endif
