// 
// File:          integrators_MidpointIntegrator.cc
// Symbol:        integrators.MidpointIntegrator-v1.0
// Symbol Type:   class
// Babel Version: 0.9.3
// Description:   Client-side glue code for integrators.MidpointIntegrator
// 
// WARNING: Automatically generated; changes will be lost
// 
// babel-version = 0.9.3
// 

#ifndef included_integrators_MidpointIntegrator_hh
#include "integrators_MidpointIntegrator.hh"
#endif
#ifndef included_sidl_BaseInterface_hh
#include "sidl_BaseInterface.hh"
#endif
#ifndef included_sidl_BaseClass_hh
#include "sidl_BaseClass.hh"
#endif
#ifndef included_sidl_BaseException_hh
#include "sidl_BaseException.hh"
#endif
#include "sidl_String.h"
#include "babel_config.h"
#ifdef SIDL_DYNAMIC_LIBRARY
#include <stdio.h>
#include <stdlib.h>
#include "sidl_Loader.hh"
#endif


//////////////////////////////////////////////////
// 
// User Defined Methods
// 


/**
 * <p>
 * Add one to the intrinsic reference count in the underlying object.
 * Object in <code>sidl</code> have an intrinsic reference count.
 * Objects continue to exist as long as the reference count is
 * positive. Clients should call this method whenever they
 * create another ongoing reference to an object or interface.
 * </p>
 * <p>
 * This does not have a return value because there is no language
 * independent type that can refer to an interface or a
 * class.
 * </p>
 */
void
integrators::MidpointIntegrator::addRef(  )
throw ( ::sidl::NullIORException ) 

{
  if ( d_self == 0 ) {
    throw ::sidl::NullIORException( ::std::string (
      "Null IOR Pointer in \"integrators::MidpointIntegrator::addRef()\""
    ));
  }

  if ( !d_weak_reference ) {
    // pack args to dispatch to ior

    // dispatch to ior
    (*(d_self->d_epv->f_addRef))(d_self );
    // unpack results and cleanup

  }
}



/**
 * Decrease by one the intrinsic reference count in the underlying
 * object, and delete the object if the reference is non-positive.
 * Objects in <code>sidl</code> have an intrinsic reference count.
 * Clients should call this method whenever they remove a
 * reference to an object or interface.
 */
void
integrators::MidpointIntegrator::deleteRef(  )
throw ( ::sidl::NullIORException ) 

{
  if ( d_self == 0 ) {
    throw ::sidl::NullIORException( ::std::string (
      "Null IOR Pointer in \"integrators::MidpointIntegrator::deleteRef()\""
    ));
  }

  if ( !d_weak_reference ) {
    // pack args to dispatch to ior

    // dispatch to ior
    (*(d_self->d_epv->f_deleteRef))(d_self );
    // unpack results and cleanup

    d_self = 0;
  }
}



/**
 * Return true if and only if <code>obj</code> refers to the same
 * object as this object.
 */
bool
integrators::MidpointIntegrator::isSame( /*in*/ ::sidl::BaseInterface iobj )
throw ( ::sidl::NullIORException ) 

{
  if ( d_self == 0 ) {
    throw ::sidl::NullIORException( ::std::string (
      "Null IOR Pointer in \"integrators::MidpointIntegrator::isSame()\""
    ));
  }
  bool _result;
  // pack args to dispatch to ior
  sidl_bool _local_result;
  // dispatch to ior
  _local_result = (*(d_self->d_epv->f_isSame))(d_self,
    /* in */ iobj._get_ior() );
  // unpack results and cleanup
  _result = _local_result;
  return _result;
}



/**
 * Check whether the object can support the specified interface or
 * class.  If the <code>sidl</code> type name in <code>name</code>
 * is supported, then a reference to that object is returned with the
 * reference count incremented.  The callee will be responsible for
 * calling <code>deleteRef</code> on the returned object.  If
 * the specified type is not supported, then a null reference is
 * returned.
 */
::sidl::BaseInterface
integrators::MidpointIntegrator::queryInt( /*in*/ const ::std::string& name )
throw ( ::sidl::NullIORException ) 

{
  if ( d_self == 0 ) {
    throw ::sidl::NullIORException( ::std::string (
      "Null IOR Pointer in \"integrators::MidpointIntegrator::queryInt()\""
    ));
  }
  ::sidl::BaseInterface _result;
  // pack args to dispatch to ior

  // dispatch to ior
  _result = ::sidl::BaseInterface( (*(d_self->d_epv->f_queryInt))(d_self,
    /* in */ name.c_str() ), false);
  // unpack results and cleanup

  return _result;
}



/**
 * Return whether this object is an instance of the specified type.
 * The string name must be the <code>sidl</code> type name.  This
 * routine will return <code>true</code> if and only if a cast to
 * the string type name would succeed.
 */
bool
integrators::MidpointIntegrator::isType( /*in*/ const ::std::string& name )
throw ( ::sidl::NullIORException ) 

{
  if ( d_self == 0 ) {
    throw ::sidl::NullIORException( ::std::string (
      "Null IOR Pointer in \"integrators::MidpointIntegrator::isType()\""
    ));
  }
  bool _result;
  // pack args to dispatch to ior
  sidl_bool _local_result;
  // dispatch to ior
  _local_result = (*(d_self->d_epv->f_isType))(d_self, /* in */ name.c_str() );
  // unpack results and cleanup
  _result = _local_result;
  return _result;
}



/**
 * Return the meta-data about the class implementing this interface.
 */
::sidl::ClassInfo
integrators::MidpointIntegrator::getClassInfo(  )
throw ( ::sidl::NullIORException ) 

{
  if ( d_self == 0 ) {
    throw ::sidl::NullIORException( ::std::string (
      "Null IOR Pointer in \"integrators::MidpointIntegrator::getClassInfo()\""
    ));
  }
  ::sidl::ClassInfo _result;
  // pack args to dispatch to ior

  // dispatch to ior
  _result = ::sidl::ClassInfo( (*(d_self->d_epv->f_getClassInfo))(d_self ),
    false);
  // unpack results and cleanup

  return _result;
}


/**
 * user defined non-static method.
 */
double
integrators::MidpointIntegrator::integrate( /*in*/ double lowBound,
  /*in*/ double upBound, /*in*/ int32_t count )
throw ( ::sidl::NullIORException ) 

{
  if ( d_self == 0 ) {
    throw ::sidl::NullIORException( ::std::string (
      "Null IOR Pointer in \"integrators::MidpointIntegrator::integrate()\""
    ));
  }
  double _result;
  // pack args to dispatch to ior

  // dispatch to ior
  _result = (*(d_self->d_epv->f_integrate))(d_self, /* in */ lowBound,
    /* in */ upBound, /* in */ count );
  // unpack results and cleanup

  return _result;
}



/**
 * Starts up a component presence in the calling framework.
 * @param Svc the component instance's handle on the framework world.
 * Contracts concerning Svc and setServices:
 * 
 * The component interaction with the CCA framework
 * and Ports begins on the call to setServices by the framework.
 * 
 * This function is called exactly once for each instance created
 * by the framework.
 * 
 * The argument Svc will never be nil/null.
 * 
 * Those uses ports which are automatically connected by the framework
 * (so-called service-ports) may be obtained via getPort during
 * setServices.
 */
void
integrators::MidpointIntegrator::setServices( /*in*/ ::gov::cca::Services 
  services )
throw ( 
  ::sidl::NullIORException, ::gov::cca::CCAException
)
{
  if ( d_self == 0 ) {
    throw ::sidl::NullIORException( ::std::string (
      "Null IOR Pointer in \"integrators::MidpointIntegrator::setServices()\""
    ));
  }

  // pack args to dispatch to ior
  sidl_BaseInterface__object * _exception = 0;
  // dispatch to ior
  (*(d_self->d_epv->f_setServices))(d_self, /* in */ services._get_ior(),
    &_exception );
  // unpack results and cleanup
  if (_exception != 0 ) {
    void * _p = 0;
    if ( (_p=(*(_exception->d_epv->f__cast))(_exception,
      "gov.cca.CCAException")) != 0 ) {
      struct gov_cca_CCAException__object * _realtype = reinterpret_cast< 
        struct gov_cca_CCAException__object*>(_p);
      // Note: alternate constructor does not increment refcount.
      throw ::gov::cca::CCAException( _realtype, false );
    }
  }

}



//////////////////////////////////////////////////
// 
// End User Defined Methods
// (everything else in this file is specific to
//  Babel's C++ bindings)
// 

// static constructor
::integrators::MidpointIntegrator
integrators::MidpointIntegrator::_create() {
  ::integrators::MidpointIntegrator self( (*_get_ext()->createObject)(),
    false );
  return self;
}

// default destructor
integrators::MidpointIntegrator::~MidpointIntegrator () {
  if ( d_self != 0 ) {
    deleteRef();
  }
}

// copy constructor
integrators::MidpointIntegrator::MidpointIntegrator ( const 
  ::integrators::MidpointIntegrator& original ) {
  d_self = const_cast< ior_t*>(original.d_self);
  d_weak_reference = original.d_weak_reference;
  if (d_self != 0 ) {
    addRef();
  }
}

// assignment operator
::integrators::MidpointIntegrator&
integrators::MidpointIntegrator::operator=( const 
  ::integrators::MidpointIntegrator& rhs ) {
  if ( d_self != rhs.d_self ) {
    if ( d_self != 0 ) {
      deleteRef();
    }
    d_self = const_cast< ior_t*>(rhs.d_self);
    d_weak_reference = rhs.d_weak_reference;
    if ( d_self != 0 ) {
      addRef();
    }
  }
  return *this;
}

// conversion from ior to C++ class
integrators::MidpointIntegrator::MidpointIntegrator ( 
  ::integrators::MidpointIntegrator::ior_t* ior ) 
    : d_self( ior ), d_weak_reference(false) {
  if ( d_self != 0 ) {
    addRef();
  }
}

// Alternate constructor: does not call addRef()
// (sets d_weak_reference=isWeak)
// For internal use by Impls (fixes bug#275)
integrators::MidpointIntegrator::MidpointIntegrator ( 
  ::integrators::MidpointIntegrator::ior_t* ior, bool isWeak ) 
    : d_self( ior ), d_weak_reference(isWeak) { 
}

// conversion from a StubBase
integrators::MidpointIntegrator::MidpointIntegrator ( const ::sidl::StubBase& 
  base )
{
  d_self = reinterpret_cast< 
    ior_t*>(base._cast("integrators.MidpointIntegrator"));
  d_weak_reference = false;
  if (d_self != 0) {
    addRef();
  }
}

// protected method that implements casting
void* integrators::MidpointIntegrator::_cast(const char* type) const
{
  void* ptr = 0;
  if ( d_self != 0 ) {
    ptr = reinterpret_cast< void*>((*d_self->d_epv->f__cast)(d_self, type));
  }
  return ptr;
}

// Static data type
const ::integrators::MidpointIntegrator::ext_t * 
  integrators::MidpointIntegrator::s_ext = 0;

// private static method to get static data type
const ::integrators::MidpointIntegrator::ext_t *
integrators::MidpointIntegrator::_get_ext()
  throw (::sidl::NullIORException)
{
  if (! s_ext ) {
#ifdef SIDL_STATIC_LIBRARY
    s_ext = integrators_MidpointIntegrator__externals();
#else
    ::sidl::DLL dll = ::sidl::DLL::_create();
    const ext_t *(*dll_f)(void);
    // check global namespace for symbol first
    if (dll._not_nil() && dll.loadLibrary("main:", TRUE, FALSE)) {
      dll_f =
        (const ext_t *(*)(void)) dll.lookupSymbol(
          "integrators_MidpointIntegrator__externals");
      s_ext = (dll_f ? (*dll_f)() : NULL);
    }
    if (!s_ext) {
      dll = ::sidl::Loader::findLibrary("integrators.MidpointIntegrator",
        "ior/impl", ::sidl::Scope_SCLSCOPE,
        ::sidl::Resolve_SCLRESOLVE);
      if (dll._not_nil()) {
        dll_f =
          (const ext_t *(*)(void)) dll.lookupSymbol(
            "integrators_MidpointIntegrator__externals");
        s_ext = (dll_f ? (*dll_f)() : NULL);
      }
    }
    if (!s_ext) {
      throw ::sidl::NullIORException( ::std::string (
        "cannot find implementation for integrators.MidpointIntegrator; please set SIDL_DLL_PATH"
      ));
    }
#endif
  }
  return s_ext;
}

