// 
// File:          integrators_MonteCarloIntegrator_Impl.cc
// Symbol:        integrators.MonteCarloIntegrator-v1.0
// Symbol Type:   class
// Babel Version: 0.9.3
// Description:   Server-side implementation for integrators.MonteCarloIntegrator
// 
// WARNING: Automatically generated; only changes within splicers preserved
// 
// babel-version = 0.9.3
// 
#include "integrators_MonteCarloIntegrator_Impl.hh"

// DO-NOT-DELETE splicer.begin(integrators.MonteCarloIntegrator._includes)
// Put additional includes or other arbitrary code here...
#include <stdio.h>
#include <functions_Function.hh>
#include "randomgen_RandomGenerator.hh"
#include <performance_Measurement.hh>
#include <iostream>
using namespace std;
// DO-NOT-DELETE splicer.end(integrators.MonteCarloIntegrator._includes)

// user defined constructor
void integrators::MonteCarloIntegrator_impl::_ctor() {
  // DO-NOT-DELETE splicer.begin(integrators.MonteCarloIntegrator._ctor)
  // add construction details here
  // DO-NOT-DELETE splicer.end(integrators.MonteCarloIntegrator._ctor)
}

// user defined destructor
void integrators::MonteCarloIntegrator_impl::_dtor() {
  // DO-NOT-DELETE splicer.begin(integrators.MonteCarloIntegrator._dtor)
  // add destruction details here
  // DO-NOT-DELETE splicer.end(integrators.MonteCarloIntegrator._dtor)
}

// user defined static methods: (none)

// user defined non-static methods:
/**
 * Method:  integrate[]
 */
double
integrators::MonteCarloIntegrator_impl::integrate (
  /*in*/ double lowBound,
  /*in*/ double upBound,
  /*in*/ int32_t count ) 
throw () 
{
  // DO-NOT-DELETE splicer.begin(integrators.MonteCarloIntegrator.integrate)
  // insert implementation here
  
   gov::cca::Port port;
   double sum = 0.0;
   functions::Function function_m;
   static performance::Measurement measurement_m;
   randomgen::RandomGenerator random_m;

     // Get RandomGenerator port  

   port = frameworkServices.getPort ("RandomGeneratorPort");
   if (port._not_nil ())
      random_m = port;
   if (random_m._is_nil ()) {
      cerr << "Connected to something other than a RandomGenerator port" << endl;
      return -1;
   }

         // Get Function port
   port = frameworkServices.getPort ("FunctionPort");
   if (port._not_nil ())
      function_m = port;

   if (function_m._is_nil ()) {
      cerr << "Connected to something other than a Function port" << endl;
      return -1;
   }
   
         // Get Measurement port
   port = frameworkServices.getPort ("MeasurementPort");
   if (port._not_nil ())
      measurement_m = port;

   if (function_m._is_nil ()) {
      cerr << "Connected to something other than a Measurement port" << endl;
      return -1;
   }

   static performance::Timer top = measurement_m.createTimerWithNameTypeGroup("Top Level", "Type", "TAU_GROUP_CCA");

   static performance::Timer line = measurement_m.createTimerWithNameTypeGroup("loop", "", "TAU_GROUP_CCA");
   static performance::Query query = measurement_m.createQuery();
   static performance::Timer third = measurement_m.createTimerWithNameTypeGroup("Third", "", "TAU_GROUP_CCA");

   top.start(); 
   for (int i = 0; i < count; i++) { double x = random_m.getRandomNumber ();
      line.start();
      x =  lowBound + (upBound - lowBound) * x;
      sum = sum + function_m.evaluate (x);
      line.stop();
   }
   ::sidl::array< ::std::string> nm = query.getTimerNames();
   ::sidl::array< ::std::string> ct = query.getCounterNames();
   cout <<"Name of counter 0 : "<<ct.get(0)<<endl;
   for (int j = nm.lower(0); j < nm.upper(0)+1; j++)
   {
      cout <<"Name of Timer "<< j << " = " <<nm.get(j)<<endl;
   }
   ::sidl::array< double> ex, in;
   ::sidl::array< int> numCalls, numChildCalls;
   ::sidl::array< ::std::string> counterNames;
   int numCounters; 
   query.getTimerData(nm, ex, in, numCalls, numChildCalls, counterNames, 
		   numCounters);
   cout <<"Num of Counters = "<< numCounters <<endl;
   cout <<"Calls for loop func: "<<numCalls.get(1)<<endl;
   cout <<"Counter 0 name = "<<counterNames.get(0) <<endl;
   //query.dumpTimerDataIncremental(nm);
   top.stop(); 

      // Release ports
   frameworkServices.releasePort ("RandomGeneratorPort");
   frameworkServices.releasePort ("FunctionPort");
   frameworkServices.releasePort ("MeasurementPort");

   return (upBound - lowBound) * sum / count;
  
  // DO-NOT-DELETE splicer.end(integrators.MonteCarloIntegrator.integrate)
}

/**
 * Starts up a component presence in the calling framework.
 * @param Svc the component instance's handle on the framework world.
 * Contracts concerning Svc and setServices:
 * 
 * The component interaction with the CCA framework
 * and Ports begins on the call to setServices by the framework.
 * 
 * This function is called exactly once for each instance created
 * by the framework.
 * 
 * The argument Svc will never be nil/null.
 * 
 * Those uses ports which are automatically connected by the framework
 * (so-called service-ports) may be obtained via getPort during
 * setServices.
 */
void
integrators::MonteCarloIntegrator_impl::setServices (
  /*in*/ ::gov::cca::Services services ) 
throw ( 
  ::gov::cca::CCAException
){
  // DO-NOT-DELETE splicer.begin(integrators.MonteCarloIntegrator.setServices)
  // insert implementation here
  
   frameworkServices = services;

  fprintf(stderr, "%s:%d: setServices() is called\n",  __FILE__, __LINE__);
   if (frameworkServices._not_nil ()) {
      gov::cca::TypeMap tm = frameworkServices.createTypeMap ();
      if (tm._is_nil ()) {
         fprintf (stderr, "%s:%d: gov::cca::TypeMap is nil\n",
                  __FILE__, __LINE__);
      }

      gov::cca::Port p = self;     //Babel required cast

      if (p._is_nil ()) {
         fprintf (stderr, "p is nil\n");
      }

      frameworkServices.addProvidesPort (p,
                                         "IntegratorPort",
                                         "integrators.Integrator", tm);

      // The Ports I use 

      try {
         frameworkServices.registerUsesPort ("FunctionPort", "functions.Function",
                                             tm);
         frameworkServices.registerUsesPort ("RandomGeneratorPort",
                                             "randomgen.RandomGenerator", tm);
         frameworkServices.registerUsesPort ("MeasurementPort",
                                             "performance.Measurement", tm);
      }
      catch (std::exception & e) {
         fprintf (stderr, "exception caught: %s", e.what ());
      }
   }
   else {
      fprintf (stderr, "%s:%d: integrators.Integrator services is nil\n",
               __FILE__, __LINE__);
   }
    
  // DO-NOT-DELETE splicer.end(integrators.MonteCarloIntegrator.setServices)
}


// DO-NOT-DELETE splicer.begin(integrators.MonteCarloIntegrator._misc)
// Put miscellaneous code here
// DO-NOT-DELETE splicer.end(integrators.MonteCarloIntegrator._misc)

