// 
// File:          integrators_ParallelIntegrator_Impl.cc
// Symbol:        integrators.ParallelIntegrator-v1.0
// Symbol Type:   class
// Babel Version: 0.9.3
// Description:   Server-side implementation for integrators.ParallelIntegrator
// 
// WARNING: Automatically generated; only changes within splicers preserved
// 
// babel-version = 0.9.3
// 
#include "integrators_ParallelIntegrator_Impl.hh"

// DO-NOT-DELETE splicer.begin(integrators.ParallelIntegrator._includes)
// Put additional includes or other arbitrary code here...
# include <mpi.h>
# include <stdio.h>
# include "functions_Function.hh"
# include <iostream>
using namespace std;
// DO-NOT-DELETE splicer.end(integrators.ParallelIntegrator._includes)

// user defined constructor
void integrators::ParallelIntegrator_impl::_ctor() {
  // DO-NOT-DELETE splicer.begin(integrators.ParallelIntegrator._ctor)
  // add construction details here
  // DO-NOT-DELETE splicer.end(integrators.ParallelIntegrator._ctor)
}

// user defined destructor
void integrators::ParallelIntegrator_impl::_dtor() {
  // DO-NOT-DELETE splicer.begin(integrators.ParallelIntegrator._dtor)
  // add destruction details here
  // DO-NOT-DELETE splicer.end(integrators.ParallelIntegrator._dtor)
}

// user defined static methods: (none)

// user defined non-static methods:
/**
 * Method:  integrate[]
 */
double
integrators::ParallelIntegrator_impl::integrate (
  /*in*/ double lowBound,
  /*in*/ double upBound,
  /*in*/ int32_t count ) 
throw () 
{
  // DO-NOT-DELETE splicer.begin(integrators.ParallelIntegrator.integrate)
  // insert implementation here
  
   gov::cca::Port port;
   functions::Function function_m;

         // Get Function port
   port = frameworkServices.getPort("FunctionPort");
   if (port._not_nil())
      function_m = port;

   if (function_m._is_nil()) {
      cerr << "Connected to something other than a Function port" << endl;
      return -1;
   }
   int n, myid, numprocs, i;
   double result = 0.0, myresult, h, sum, x;
   int namelen;
   char processor_name[MPI_MAX_PROCESSOR_NAME];

   MPI_Comm_size(MPI_COMM_WORLD, &numprocs);
   MPI_Comm_rank(MPI_COMM_WORLD, &myid);
   MPI_Get_processor_name(processor_name, &namelen);

   fprintf(stderr, "Process %d on %s: number of intervals = %d\n", 
           myid, processor_name, count);

   MPI_Bcast(&count, 1, MPI_INT, 0, MPI_COMM_WORLD);
   if (count == 0) {
      return -1;
   } else {
      h = (upBound - lowBound) / (double) count;
      sum = 0.0;
      for (i = myid + 1; i <= count; i += numprocs) {
         x = h * ((double) i - 0.5);
         sum += function_m.evaluate(x);
      }
      myresult = h * sum;

      MPI_Reduce(&myresult, &result, 1, MPI_DOUBLE, MPI_SUM, 0,
                 MPI_COMM_WORLD);

      printf("Process %d on %s: myresult = %lf\n", myid,
                       processor_name, myresult);
   }

            // Release ports
   frameworkServices.releasePort("FunctionPort");
   printf("Process %d on %s: Final result is = %lf\n", myid,
                    processor_name, result);
   fflush(stdout);
   
   return result;
      
  // DO-NOT-DELETE splicer.end(integrators.ParallelIntegrator.integrate)
}

/**
 * Starts up a component presence in the calling framework.
 * @param Svc the component instance's handle on the framework world.
 * Contracts concerning Svc and setServices:
 * 
 * The component interaction with the CCA framework
 * and Ports begins on the call to setServices by the framework.
 * 
 * This function is called exactly once for each instance created
 * by the framework.
 * 
 * The argument Svc will never be nil/null.
 * 
 * Those uses ports which are automatically connected by the framework
 * (so-called service-ports) may be obtained via getPort during
 * setServices.
 */
void
integrators::ParallelIntegrator_impl::setServices (
  /*in*/ ::gov::cca::Services services ) 
throw ( 
  ::gov::cca::CCAException
){
  // DO-NOT-DELETE splicer.begin(integrators.ParallelIntegrator.setServices)
  // insert implementation here
   frameworkServices = services;

   if (frameworkServices._not_nil ()) {
      gov::cca::TypeMap tm = frameworkServices.createTypeMap ();
      if (tm._is_nil ()) {
        fprintf (stderr, "%s:%d: gov::cca::TypeMap is nil\n",
                  __FILE__, __LINE__);
      }

      gov::cca::Port p = self;         // Babel required cast

      if (p._is_nil ()) {
         fprintf (stderr, "p is nil\n");
      }

      frameworkServices.addProvidesPort (p, "IntegratorPort", "integrators.Integrator", tm);

      // The Ports I use 

      try {
         frameworkServices.registerUsesPort("FunctionPort", "functions.Function",
                                             tm);
      }
      catch (std::exception & e) {
         fprintf (stderr, "exception caught: %s", e.what ());
      }
   }
   else {
      fprintf (stderr, "%s:%d: integrators.Integrator services is nil\n",
               __FILE__, __LINE__);
   }
  // DO-NOT-DELETE splicer.end(integrators.ParallelIntegrator.setServices)
}


// DO-NOT-DELETE splicer.begin(integrators.ParallelIntegrator._misc)
// Put miscellaneous code here
// DO-NOT-DELETE splicer.end(integrators.ParallelIntegrator._misc)

