// 
// File:          performance_TauQuery_Impl.cc
// Symbol:        performance.TauQuery-v1.0
// Symbol Type:   class
// Babel Version: 0.9.3
// Description:   Server-side implementation for performance.TauQuery
// 
// WARNING: Automatically generated; only changes within splicers preserved
// 
// babel-version = 0.9.3
// 
#include "performance_TauQuery_Impl.hh"

// DO-NOT-DELETE splicer.begin(performance.TauQuery._includes)
// Put additional includes or other arbitrary code here...
#include <stdio.h>
#include <iostream>
//#include <babel_config.h>

using namespace std;
// DO-NOT-DELETE splicer.end(performance.TauQuery._includes)

// user defined constructor
void performance::TauQuery_impl::_ctor() {
  // DO-NOT-DELETE splicer.begin(performance.TauQuery._ctor)
  // add construction details here
  // DO-NOT-DELETE splicer.end(performance.TauQuery._ctor)
}

// user defined destructor
void performance::TauQuery_impl::_dtor() {
  // DO-NOT-DELETE splicer.begin(performance.TauQuery._dtor)
  // add destruction details here
  // DO-NOT-DELETE splicer.end(performance.TauQuery._dtor)
}

// user defined static methods: (none)

// user defined non-static methods:
/**
 * Method:  getTimerNames[]
 */
::sidl::array< ::std::string>
performance::TauQuery_impl::getTimerNames () 
throw () 

{
  // DO-NOT-DELETE splicer.begin(performance.TauQuery.getTimerNames)
  // insert implementation here
  const char **timerList;
  int numTimers;
  TAU_GET_FUNC_NAMES(timerList, numTimers);

  ::sidl::array< ::std::string> 
	  timers = ::sidl::array< ::std::string>::create1d(numTimers);
  for (int i = 0; i < numTimers; i++)
  {
     timers.set(i, ::std::string(timerList[i]));
  }
  
  return timers;
  // DO-NOT-DELETE splicer.end(performance.TauQuery.getTimerNames)
}

/**
 * Method:  getCounterNames[]
 */
::sidl::array< ::std::string>
performance::TauQuery_impl::getCounterNames () 
throw () 

{
  // DO-NOT-DELETE splicer.begin(performance.TauQuery.getCounterNames)
  // insert implementation here
  const char **counterList;
  int numCounters;
  TAU_GET_COUNTER_NAMES(counterList, numCounters);

  ::sidl::array< ::std::string> 
	  counters = ::sidl::array< ::std::string>::create1d(numCounters);
  for (int i = 0; i < numCounters; i++)
  {
     counters.set(i, ::std::string(counterList[i]));
     delete counterList[i]; 
  }
  
  delete counterList;
  return counters;
  // DO-NOT-DELETE splicer.end(performance.TauQuery.getCounterNames)
}

/**
 * Method:  getTimerData[]
 */
void
performance::TauQuery_impl::getTimerData (
  /*in*/ ::sidl::array< ::std::string> timerList,
  /*out*/ ::sidl::array<double>& counterExclusive,
  /*out*/ ::sidl::array<double>& counterInclusive,
  /*out*/ ::sidl::array<int32_t>& numCalls,
  /*out*/ ::sidl::array<int32_t>& numChildCalls,
  /*out*/ ::sidl::array< ::std::string>& counterNames,
  /*out*/ int32_t& numCounters ) 
throw () 
{
  // DO-NOT-DELETE splicer.begin(performance.TauQuery.getTimerData)
  // insert implementation here
  int numTimers = timerList.upper(0) - timerList.lower(0) + 1 ; 
  // assuming a stride of 1 

  // First create the list of timer names
  const char **tlist = (const char **) malloc (sizeof (char *) * numTimers); 
  for (int i = 0; i < numTimers; i++)
  {
    tlist[i] = strdup(timerList.get(i).c_str());
  }
  double **exclusive;
  double **inclusive;
  int *calls;
  int *childcalls;
  const char **counterlist;

  // Then get all the values in local variables
  TAU_GET_FUNC_VALS(tlist, numTimers, exclusive, inclusive, 
		  calls, childcalls,
		  counterlist, numCounters);

  // Create arrays (1d, 2d) for passing the values back
  int32_t dim = 2;
  int32_t lower[2] = {0,0}; // zero offset
  int32_t upper[2] = {numTimers-1, numCounters-1}; 

  counterExclusive = ::sidl::array< double>::createRow(dim, lower, upper);
  counterInclusive = ::sidl::array< double>::createRow(dim, lower, upper);

  int32_t callsDim = 1;
  int32_t callsLower [1] = {0}; // zero offset
  int32_t callsUpper [1] = {numTimers - 1}; 

  numCalls = ::sidl::array< int>::createRow(callsDim, callsLower, callsUpper);
  numChildCalls = ::sidl::array< int>::createRow(callsDim, callsLower, callsUpper);
  counterNames = ::sidl::array< ::std::string>::createRow(callsDim, callsLower, callsUpper);

  // Copy values from local arrays to sidl arrays and delete local storage
  for (int fns = 0; fns < numTimers; fns ++) {
    numCalls.set(fns, calls[fns]);
    numChildCalls.set(fns, childcalls[fns]);
    for (int cnt = 0; cnt < numCounters; cnt++) {
      printf("Counter name %s\n", counterlist[cnt]);
      cout << "The Exclusive value of: " << tlist[fns]
	   << " is: " << exclusive[fns][0] << endl;
      counterExclusive.set(fns, cnt, exclusive[fns][cnt]); 
      counterInclusive.set(fns, cnt, inclusive[fns][cnt]); 
      cout << "The Inclusive value of: " << tlist[fns]
	   << " is: " << inclusive[fns][0] << endl;
      cout << "The numOfCalls of: " << tlist[fns]
           << " is: " << calls[fns] << endl;
      
      printf("Function %d:%s exclusive time = %f \n", fns, 
	     timerList.get(fns).c_str(), exclusive[fns][cnt]); 
    }
    
    printf("Num calls = %d\n", calls[fns]);
    delete exclusive[fns];
    delete inclusive[fns];
    delete tlist[fns];
  }
  
  delete exclusive;
  delete inclusive;
  delete calls;
  delete childcalls;
  delete tlist;
  // delete the arrays


  // copy the names of counters to the sidl counterNames array and delete
  // local storage
  for (int counters = 0; counters < numCounters; counters++)
  {
    counterNames.set(counters, counterlist[counters]);
    delete counterlist[counters];
  }
  delete counterlist;
  // DO-NOT-DELETE splicer.end(performance.TauQuery.getTimerData)
}

/**
 * Method:  dumpProfileData[]
 */
void
performance::TauQuery_impl::dumpProfileData () 
throw () 

{
  // DO-NOT-DELETE splicer.begin(performance.TauQuery.dumpProfileData)
  // insert implementation here
  TAU_DB_DUMP();
  // DO-NOT-DELETE splicer.end(performance.TauQuery.dumpProfileData)
}

/**
 * Method:  dumpProfileDataIncremental[]
 */
void
performance::TauQuery_impl::dumpProfileDataIncremental () 
throw () 

{
  // DO-NOT-DELETE splicer.begin(performance.TauQuery.dumpProfileDataIncremental)
  // insert implementation here
  TAU_DB_DUMP_INCR();
  // DO-NOT-DELETE splicer.end(performance.TauQuery.dumpProfileDataIncremental)
}

/**
 * Method:  dumpTimerNames[]
 */
void
performance::TauQuery_impl::dumpTimerNames () 
throw () 

{
  // DO-NOT-DELETE splicer.begin(performance.TauQuery.dumpTimerNames)
  // insert implementation here
  TAU_DUMP_FUNC_NAMES();
  // DO-NOT-DELETE splicer.end(performance.TauQuery.dumpTimerNames)
}

/**
 * Method:  dumpTimerData[]
 */
void
performance::TauQuery_impl::dumpTimerData (
  /*in*/ ::sidl::array< ::std::string> timerList ) 
throw () 
{
  // DO-NOT-DELETE splicer.begin(performance.TauQuery.dumpTimerData)
  // insert implementation here
  int numTimers = timerList.upper(0) - timerList.lower(0) + 1 ; 
  // assuming a stride of 1 

  // First create the list of timer names
  const char **tlist = (const char **) malloc (sizeof (char *) * numTimers); 
  for (int i = 0; i < numTimers; i++)
  {
    tlist[i] = strdup(timerList.get(i).c_str());
  }
  TAU_DUMP_FUNC_VALS(tlist, numTimers);

  for (int i = 0; i < numTimers; i++)
  {
    delete tlist[i];
  }
  delete tlist;
  // DO-NOT-DELETE splicer.end(performance.TauQuery.dumpTimerData)
}

/**
 * Method:  dumpTimerDataIncremental[]
 */
void
performance::TauQuery_impl::dumpTimerDataIncremental (
  /*in*/ ::sidl::array< ::std::string> timerList ) 
throw () 
{
  // DO-NOT-DELETE splicer.begin(performance.TauQuery.dumpTimerDataIncremental)
  // insert implementation here
  int numTimers = timerList.upper(0) - timerList.lower(0) + 1 ; 
  // assuming a stride of 1 

  // First create the list of timer names
  const char **tlist = (const char **) malloc (sizeof (char *) * numTimers); 
  for (int i = 0; i < numTimers; i++)
  {
    tlist[i] = strdup(timerList.get(i).c_str());
  }
  TAU_DUMP_FUNC_VALS_INCR(tlist, numTimers);
  // DO-NOT-DELETE splicer.end(performance.TauQuery.dumpTimerDataIncremental)
}


// DO-NOT-DELETE splicer.begin(performance.TauQuery._misc)
// Put miscellaneous code here
// DO-NOT-DELETE splicer.end(performance.TauQuery._misc)

