// 
// File:          performance_Timer.cc
// Symbol:        performance.Timer-v1.0
// Symbol Type:   interface
// Babel Version: 0.9.3
// Description:   Client-side glue code for performance.Timer
// 
// WARNING: Automatically generated; changes will be lost
// 
// babel-version = 0.9.3
// 

#ifndef included_performance_Timer_hh
#include "performance_Timer.hh"
#endif
#ifndef included_sidl_BaseInterface_hh
#include "sidl_BaseInterface.hh"
#endif
#ifndef included_sidl_BaseClass_hh
#include "sidl_BaseClass.hh"
#endif
#include "sidl_String.h"
#include "babel_config.h"
#ifdef SIDL_DYNAMIC_LIBRARY
#include <stdio.h>
#include <stdlib.h>
#include "sidl_Loader.hh"
#endif


//////////////////////////////////////////////////
// 
// User Defined Methods
// 


/**
 * <p>
 * Add one to the intrinsic reference count in the underlying object.
 * Object in <code>sidl</code> have an intrinsic reference count.
 * Objects continue to exist as long as the reference count is
 * positive. Clients should call this method whenever they
 * create another ongoing reference to an object or interface.
 * </p>
 * <p>
 * This does not have a return value because there is no language
 * independent type that can refer to an interface or a
 * class.
 * </p>
 */
void
performance::Timer::addRef(  )
throw ( ::sidl::NullIORException ) 

{
  if ( d_self == 0 ) {
    throw ::sidl::NullIORException( ::std::string (
      "Null IOR Pointer in \"performance::Timer::addRef()\""
    ));
  }

  if ( !d_weak_reference ) {
    // pack args to dispatch to ior

    // dispatch to ior
    (*(d_self->d_epv->f_addRef))(d_self->d_object );
    // unpack results and cleanup

  }
}



/**
 * Decrease by one the intrinsic reference count in the underlying
 * object, and delete the object if the reference is non-positive.
 * Objects in <code>sidl</code> have an intrinsic reference count.
 * Clients should call this method whenever they remove a
 * reference to an object or interface.
 */
void
performance::Timer::deleteRef(  )
throw ( ::sidl::NullIORException ) 

{
  if ( d_self == 0 ) {
    throw ::sidl::NullIORException( ::std::string (
      "Null IOR Pointer in \"performance::Timer::deleteRef()\""
    ));
  }

  if ( !d_weak_reference ) {
    // pack args to dispatch to ior

    // dispatch to ior
    (*(d_self->d_epv->f_deleteRef))(d_self->d_object );
    // unpack results and cleanup

    d_self = 0;
  }
}



/**
 * Return true if and only if <code>obj</code> refers to the same
 * object as this object.
 */
bool
performance::Timer::isSame( /*in*/ ::sidl::BaseInterface iobj )
throw ( ::sidl::NullIORException ) 

{
  if ( d_self == 0 ) {
    throw ::sidl::NullIORException( ::std::string (
      "Null IOR Pointer in \"performance::Timer::isSame()\""
    ));
  }
  bool _result;
  // pack args to dispatch to ior
  sidl_bool _local_result;
  // dispatch to ior
  _local_result = (*(d_self->d_epv->f_isSame))(d_self->d_object,
    /* in */ iobj._get_ior() );
  // unpack results and cleanup
  _result = _local_result;
  return _result;
}



/**
 * Check whether the object can support the specified interface or
 * class.  If the <code>sidl</code> type name in <code>name</code>
 * is supported, then a reference to that object is returned with the
 * reference count incremented.  The callee will be responsible for
 * calling <code>deleteRef</code> on the returned object.  If
 * the specified type is not supported, then a null reference is
 * returned.
 */
::sidl::BaseInterface
performance::Timer::queryInt( /*in*/ const ::std::string& name )
throw ( ::sidl::NullIORException ) 

{
  if ( d_self == 0 ) {
    throw ::sidl::NullIORException( ::std::string (
      "Null IOR Pointer in \"performance::Timer::queryInt()\""
    ));
  }
  ::sidl::BaseInterface _result;
  // pack args to dispatch to ior

  // dispatch to ior
  _result = ::sidl::BaseInterface( 
    (*(d_self->d_epv->f_queryInt))(d_self->d_object, /* in */ name.c_str() ),
    false);
  // unpack results and cleanup

  return _result;
}



/**
 * Return whether this object is an instance of the specified type.
 * The string name must be the <code>sidl</code> type name.  This
 * routine will return <code>true</code> if and only if a cast to
 * the string type name would succeed.
 */
bool
performance::Timer::isType( /*in*/ const ::std::string& name )
throw ( ::sidl::NullIORException ) 

{
  if ( d_self == 0 ) {
    throw ::sidl::NullIORException( ::std::string (
      "Null IOR Pointer in \"performance::Timer::isType()\""
    ));
  }
  bool _result;
  // pack args to dispatch to ior
  sidl_bool _local_result;
  // dispatch to ior
  _local_result = (*(d_self->d_epv->f_isType))(d_self->d_object,
    /* in */ name.c_str() );
  // unpack results and cleanup
  _result = _local_result;
  return _result;
}



/**
 * Return the meta-data about the class implementing this interface.
 */
::sidl::ClassInfo
performance::Timer::getClassInfo(  )
throw ( ::sidl::NullIORException ) 

{
  if ( d_self == 0 ) {
    throw ::sidl::NullIORException( ::std::string (
      "Null IOR Pointer in \"performance::Timer::getClassInfo()\""
    ));
  }
  ::sidl::ClassInfo _result;
  // pack args to dispatch to ior

  // dispatch to ior
  _result = ::sidl::ClassInfo( 
    (*(d_self->d_epv->f_getClassInfo))(d_self->d_object ), false);
  // unpack results and cleanup

  return _result;
}


/**
 * user defined non-static method.
 */
void
performance::Timer::start(  )
throw ( ::sidl::NullIORException ) 

{
  if ( d_self == 0 ) {
    throw ::sidl::NullIORException( ::std::string (
      "Null IOR Pointer in \"performance::Timer::start()\""
    ));
  }

  // pack args to dispatch to ior

  // dispatch to ior
  (*(d_self->d_epv->f_start))(d_self->d_object );
  // unpack results and cleanup

}


/**
 * user defined non-static method.
 */
void
performance::Timer::stop(  )
throw ( ::sidl::NullIORException ) 

{
  if ( d_self == 0 ) {
    throw ::sidl::NullIORException( ::std::string (
      "Null IOR Pointer in \"performance::Timer::stop()\""
    ));
  }

  // pack args to dispatch to ior

  // dispatch to ior
  (*(d_self->d_epv->f_stop))(d_self->d_object );
  // unpack results and cleanup

}


/**
 * user defined non-static method.
 */
void
performance::Timer::setName( /*in*/ const ::std::string& name )
throw ( ::sidl::NullIORException ) 

{
  if ( d_self == 0 ) {
    throw ::sidl::NullIORException( ::std::string (
      "Null IOR Pointer in \"performance::Timer::setName()\""
    ));
  }

  // pack args to dispatch to ior

  // dispatch to ior
  (*(d_self->d_epv->f_setName))(d_self->d_object, /* in */ name.c_str() );
  // unpack results and cleanup

}


/**
 * user defined non-static method.
 */
::std::string
performance::Timer::getName(  )
throw ( ::sidl::NullIORException ) 

{
  if ( d_self == 0 ) {
    throw ::sidl::NullIORException( ::std::string (
      "Null IOR Pointer in \"performance::Timer::getName()\""
    ));
  }
  ::std::string _result;
  // pack args to dispatch to ior
  char * _local_result;
  // dispatch to ior
  _local_result = (*(d_self->d_epv->f_getName))(d_self->d_object );
  // unpack results and cleanup
  if (_local_result) {
    _result = _local_result;
    free( _local_result );
  }
  return _result;
}


/**
 * user defined non-static method.
 */
void
performance::Timer::setType( /*in*/ const ::std::string& name )
throw ( ::sidl::NullIORException ) 

{
  if ( d_self == 0 ) {
    throw ::sidl::NullIORException( ::std::string (
      "Null IOR Pointer in \"performance::Timer::setType()\""
    ));
  }

  // pack args to dispatch to ior

  // dispatch to ior
  (*(d_self->d_epv->f_setType))(d_self->d_object, /* in */ name.c_str() );
  // unpack results and cleanup

}


/**
 * user defined non-static method.
 */
::std::string
performance::Timer::getType(  )
throw ( ::sidl::NullIORException ) 

{
  if ( d_self == 0 ) {
    throw ::sidl::NullIORException( ::std::string (
      "Null IOR Pointer in \"performance::Timer::getType()\""
    ));
  }
  ::std::string _result;
  // pack args to dispatch to ior
  char * _local_result;
  // dispatch to ior
  _local_result = (*(d_self->d_epv->f_getType))(d_self->d_object );
  // unpack results and cleanup
  if (_local_result) {
    _result = _local_result;
    free( _local_result );
  }
  return _result;
}


/**
 * user defined non-static method.
 */
void
performance::Timer::setGroupName( /*in*/ const ::std::string& name )
throw ( ::sidl::NullIORException ) 

{
  if ( d_self == 0 ) {
    throw ::sidl::NullIORException( ::std::string (
      "Null IOR Pointer in \"performance::Timer::setGroupName()\""
    ));
  }

  // pack args to dispatch to ior

  // dispatch to ior
  (*(d_self->d_epv->f_setGroupName))(d_self->d_object, /* in */ name.c_str() );
  // unpack results and cleanup

}


/**
 * user defined non-static method.
 */
::std::string
performance::Timer::getGroupName(  )
throw ( ::sidl::NullIORException ) 

{
  if ( d_self == 0 ) {
    throw ::sidl::NullIORException( ::std::string (
      "Null IOR Pointer in \"performance::Timer::getGroupName()\""
    ));
  }
  ::std::string _result;
  // pack args to dispatch to ior
  char * _local_result;
  // dispatch to ior
  _local_result = (*(d_self->d_epv->f_getGroupName))(d_self->d_object );
  // unpack results and cleanup
  if (_local_result) {
    _result = _local_result;
    free( _local_result );
  }
  return _result;
}


/**
 * user defined non-static method.
 */
void
performance::Timer::setGroupId( /*in*/ int64_t group )
throw ( ::sidl::NullIORException ) 

{
  if ( d_self == 0 ) {
    throw ::sidl::NullIORException( ::std::string (
      "Null IOR Pointer in \"performance::Timer::setGroupId()\""
    ));
  }

  // pack args to dispatch to ior

  // dispatch to ior
  (*(d_self->d_epv->f_setGroupId))(d_self->d_object, /* in */ group );
  // unpack results and cleanup

}


/**
 * user defined non-static method.
 */
int64_t
performance::Timer::getGroupId(  )
throw ( ::sidl::NullIORException ) 

{
  if ( d_self == 0 ) {
    throw ::sidl::NullIORException( ::std::string (
      "Null IOR Pointer in \"performance::Timer::getGroupId()\""
    ));
  }
  int64_t _result;
  // pack args to dispatch to ior

  // dispatch to ior
  _result = (*(d_self->d_epv->f_getGroupId))(d_self->d_object );
  // unpack results and cleanup

  return _result;
}



//////////////////////////////////////////////////
// 
// End User Defined Methods
// (everything else in this file is specific to
//  Babel's C++ bindings)
// 

// default destructor
performance::Timer::~Timer () {
  if ( d_self != 0 ) {
    deleteRef();
  }
}

// copy constructor
performance::Timer::Timer ( const ::performance::Timer& original ) {
  d_self = const_cast< ior_t*>(original.d_self);
  d_weak_reference = original.d_weak_reference;
  if (d_self != 0 ) {
    addRef();
  }
}

// assignment operator
::performance::Timer&
performance::Timer::operator=( const ::performance::Timer& rhs ) {
  if ( d_self != rhs.d_self ) {
    if ( d_self != 0 ) {
      deleteRef();
    }
    d_self = const_cast< ior_t*>(rhs.d_self);
    d_weak_reference = rhs.d_weak_reference;
    if ( d_self != 0 ) {
      addRef();
    }
  }
  return *this;
}

// conversion from ior to C++ class
performance::Timer::Timer ( ::performance::Timer::ior_t* ior ) 
    : d_self( ior ), d_weak_reference(false) {
  if ( d_self != 0 ) {
    addRef();
  }
}

// Alternate constructor: does not call addRef()
// (sets d_weak_reference=isWeak)
// For internal use by Impls (fixes bug#275)
performance::Timer::Timer ( ::performance::Timer::ior_t* ior, bool isWeak ) 
    : d_self( ior ), d_weak_reference(isWeak) { 
}

// conversion from a StubBase
performance::Timer::Timer ( const ::sidl::StubBase& base )
{
  d_self = reinterpret_cast< ior_t*>(base._cast("performance.Timer"));
  d_weak_reference = false;
  if (d_self != 0) {
    addRef();
  }
}

// protected method that implements casting
void* performance::Timer::_cast(const char* type) const
{
  void* ptr = 0;
  if ( d_self != 0 ) {
    ptr = reinterpret_cast< void*>((*d_self->d_epv->f__cast)(d_self->d_object,
      type));
  }
  return ptr;
}

