// 
// File:          SIDL_Loader.cc
// Symbol:        SIDL.Loader-v0.8.2
// Symbol Type:   class
// Babel Version: 0.8.4
// Release:       $Name:  $
// Revision:      @(#) $Id: $
// Description:   Client-side glue code for SIDL.Loader
// 
// Copyright (c) 2000-2002, The Regents of the University of California.
// Produced at the Lawrence Livermore National Laboratory.
// Written by the Components Team <components@llnl.gov>
// All rights reserved.
// 
// This file is part of Babel. For more information, see
// http://www.llnl.gov/CASC/components/. Please read the COPYRIGHT file
// for Our Notice and the LICENSE file for the GNU Lesser General Public
// License.
// 
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU Lesser General Public License (as published by
// the Free Software Foundation) version 2.1 dated February 1999.
// 
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the IMPLIED WARRANTY OF
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the terms and
// conditions of the GNU Lesser General Public License for more details.
// 
// You should have recieved a copy of the GNU Lesser General Public License
// along with this program; if not, write to the Free Software Foundation,
// Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
// 
// WARNING: Automatically generated; changes will be lost
// 
// babel-version = 0.8.4
// 

#ifndef included_SIDL_Loader_hh
#include "SIDL_Loader.hh"
#endif
#ifndef included_SIDL_BaseInterface_hh
#include "SIDL_BaseInterface.hh"
#endif
#ifndef included_SIDL_BaseClass_hh
#include "SIDL_BaseClass.hh"
#endif
#include "SIDL_String.h"


//////////////////////////////////////////////////
// 
// User Defined Methods
// 


/**
 * Set the search path, which is a semi-colon separated sequence of
 * URIs as described in class <code>DLL</code>.  This method will
 * invalidate any existing search path.
 */
void
SIDL::Loader::setSearchPath( /*in*/ const ::std::string& path_name )
throw ( ::SIDL::NullIORException ) 

{

  // pack args to dispatch to ior

  // dispatch to ior
  ( _get_sepv()->f_setSearchPath)( /* in */ path_name.c_str() );
  // unpack results and cleanup

}



/**
 * Return the current search path.  If the search path has not been
 * set, then the search path will be taken from environment variable
 * SIDL_DLL_PATH.
 */
::std::string
SIDL::Loader::getSearchPath(  )
throw ( ::SIDL::NullIORException ) 

{
  ::std::string _result;
  // pack args to dispatch to ior
  char * _local_result;
  // dispatch to ior
  _local_result = ( _get_sepv()->f_getSearchPath)(  );
  // unpack results and cleanup
  if (_local_result) {
    _result = _local_result;
    free( _local_result );
  }
  return _result;
}



/**
 * Append the specified path fragment to the beginning of the
 * current search path.  If the search path has not yet been set
 * by a call to <code>setSearchPath</code>, then this fragment will
 * be appended to the path in environment variable SIDL_DLL_PATH.
 */
void
SIDL::Loader::addSearchPath( /*in*/ const ::std::string& path_fragment )
throw ( ::SIDL::NullIORException ) 

{

  // pack args to dispatch to ior

  // dispatch to ior
  ( _get_sepv()->f_addSearchPath)( /* in */ path_fragment.c_str() );
  // unpack results and cleanup

}



/**
 * Load the specified library if it has not already been loaded.
 * The URI format is defined in class <code>DLL</code>.  The search
 * path is not searched to resolve the library name.
 */
bool
SIDL::Loader::loadLibrary( /*in*/ const ::std::string& uri )
throw ( ::SIDL::NullIORException ) 

{
  bool _result;
  // pack args to dispatch to ior
  SIDL_bool _local_result;
  // dispatch to ior
  _local_result = ( _get_sepv()->f_loadLibrary)( /* in */ uri.c_str() );
  // unpack results and cleanup
  _result = (_local_result == TRUE);
  return _result;
}



/**
 * Append the specified DLL to the beginning of the list of already
 * loaded DLLs.
 */
void
SIDL::Loader::addDLL( /*in*/ ::SIDL::DLL dll )
throw ( ::SIDL::NullIORException ) 

{

  // pack args to dispatch to ior

  // dispatch to ior
  ( _get_sepv()->f_addDLL)( /* in */ dll._get_ior() );
  // unpack results and cleanup

}



/**
 * Unload all dynamic link libraries.  The library may no longer
 * be used to access symbol names.  When the library is actually
 * unloaded from the memory image depends on details of the operating
 * system.
 */
void
SIDL::Loader::unloadLibraries(  )
throw ( ::SIDL::NullIORException ) 

{

  // pack args to dispatch to ior

  // dispatch to ior
  ( _get_sepv()->f_unloadLibraries)(  );
  // unpack results and cleanup

}



/**
 * Look up the secified symbol name.  If the symbol name cannot be
 * found in one of the already loaded libraries, then the method will
 * search through the library search path.  A null is returned if the
 * symbol could not be resolved.
 */
void*
SIDL::Loader::lookupSymbol( /*in*/ const ::std::string& linker_name )
throw ( ::SIDL::NullIORException ) 

{
  void* _result;
  // pack args to dispatch to ior

  // dispatch to ior
  _result = ( _get_sepv()->f_lookupSymbol)( /* in */ linker_name.c_str() );
  // unpack results and cleanup

  return _result;
}



/**
 * Create an instance of the specified SIDL class.  If the class
 * constructor cannot be found in one of the already loaded libraries,
 * then the method will search through the library search path.  A null
 * object is returned if the symbol could not be resolved.
 */
::SIDL::BaseClass
SIDL::Loader::createClass( /*in*/ const ::std::string& sidl_name )
throw ( ::SIDL::NullIORException ) 

{
  ::SIDL::BaseClass _result;
  // pack args to dispatch to ior

  // dispatch to ior
  _result = ::SIDL::BaseClass( ( _get_sepv()->f_createClass)( /* in */ 
    sidl_name.c_str() ), false);
  // unpack results and cleanup

  return _result;
}



/**
 * <p>
 * Add one to the intrinsic reference count in the underlying object.
 * Object in <code>SIDL</code> have an intrinsic reference count.
 * Objects continue to exist as long as the reference count is
 * positive. Clients should call this method whenever they
 * create another ongoing reference to an object or interface.
 * </p>
 * <p>
 * This does not have a return value because there is no language
 * independent type that can refer to an interface or a
 * class.
 * </p>
 */
void
SIDL::Loader::addRef(  )
throw ( ::SIDL::NullIORException ) 

{
  if ( d_self == 0 ) {
    throw ::SIDL::NullIORException( ::std::string (
      "Null IOR Pointer in \"SIDL::Loader::addRef()\""
    ));
  }

  if ( !d_weak_reference ) {
    // pack args to dispatch to ior

    // dispatch to ior
    (*(d_self->d_epv->f_addRef))(d_self );
    // unpack results and cleanup

  }
}



/**
 * Decrease by one the intrinsic reference count in the underlying
 * object, and delete the object if the reference is non-positive.
 * Objects in <code>SIDL</code> have an intrinsic reference count.
 * Clients should call this method whenever they remove a
 * reference to an object or interface.
 */
void
SIDL::Loader::deleteRef(  )
throw ( ::SIDL::NullIORException ) 

{
  if ( d_self == 0 ) {
    throw ::SIDL::NullIORException( ::std::string (
      "Null IOR Pointer in \"SIDL::Loader::deleteRef()\""
    ));
  }

  if ( !d_weak_reference ) {
    // pack args to dispatch to ior

    // dispatch to ior
    (*(d_self->d_epv->f_deleteRef))(d_self );
    // unpack results and cleanup

    d_self = 0;
  }
}



/**
 * Return true if and only if <code>obj</code> refers to the same
 * object as this object.
 */
bool
SIDL::Loader::isSame( /*in*/ ::SIDL::BaseInterface iobj )
throw ( ::SIDL::NullIORException ) 

{
  if ( d_self == 0 ) {
    throw ::SIDL::NullIORException( ::std::string (
      "Null IOR Pointer in \"SIDL::Loader::isSame()\""
    ));
  }
  bool _result;
  // pack args to dispatch to ior
  SIDL_bool _local_result;
  // dispatch to ior
  _local_result = (*(d_self->d_epv->f_isSame))(d_self,
    /* in */ iobj._get_ior() );
  // unpack results and cleanup
  _result = (_local_result == TRUE);
  return _result;
}



/**
 * Check whether the object can support the specified interface or
 * class.  If the <code>SIDL</code> type name in <code>name</code>
 * is supported, then a reference to that object is returned with the
 * reference count incremented.  The callee will be responsible for
 * calling <code>deleteRef</code> on the returned object.  If
 * the specified type is not supported, then a null reference is
 * returned.
 */
::SIDL::BaseInterface
SIDL::Loader::queryInt( /*in*/ const ::std::string& name )
throw ( ::SIDL::NullIORException ) 

{
  if ( d_self == 0 ) {
    throw ::SIDL::NullIORException( ::std::string (
      "Null IOR Pointer in \"SIDL::Loader::queryInt()\""
    ));
  }
  ::SIDL::BaseInterface _result;
  // pack args to dispatch to ior

  // dispatch to ior
  _result = ::SIDL::BaseInterface( (*(d_self->d_epv->f_queryInt))(d_self,
    /* in */ name.c_str() ), false);
  // unpack results and cleanup

  return _result;
}



/**
 * Return whether this object is an instance of the specified type.
 * The string name must be the <code>SIDL</code> type name.  This
 * routine will return <code>true</code> if and only if a cast to
 * the string type name would succeed.
 */
bool
SIDL::Loader::isType( /*in*/ const ::std::string& name )
throw ( ::SIDL::NullIORException ) 

{
  if ( d_self == 0 ) {
    throw ::SIDL::NullIORException( ::std::string (
      "Null IOR Pointer in \"SIDL::Loader::isType()\""
    ));
  }
  bool _result;
  // pack args to dispatch to ior
  SIDL_bool _local_result;
  // dispatch to ior
  _local_result = (*(d_self->d_epv->f_isType))(d_self, /* in */ name.c_str() );
  // unpack results and cleanup
  _result = (_local_result == TRUE);
  return _result;
}



/**
 * Return the meta-data about the class implementing this interface.
 */
::SIDL::ClassInfo
SIDL::Loader::getClassInfo(  )
throw ( ::SIDL::NullIORException ) 

{
  if ( d_self == 0 ) {
    throw ::SIDL::NullIORException( ::std::string (
      "Null IOR Pointer in \"SIDL::Loader::getClassInfo()\""
    ));
  }
  ::SIDL::ClassInfo _result;
  // pack args to dispatch to ior

  // dispatch to ior
  _result = ::SIDL::ClassInfo( (*(d_self->d_epv->f_getClassInfo))(d_self ),
    false);
  // unpack results and cleanup

  return _result;
}



//////////////////////////////////////////////////
// 
// End User Defined Methods
// (everything else in this file is specific to
//  Babel's C++ bindings)
// 

// static constructor
::SIDL::Loader
SIDL::Loader::_create() {
  ::SIDL::Loader self( (*_get_ext()->createObject)(), false );
  return self;
}

// default destructor
SIDL::Loader::~Loader () {
  if ( d_self != 0 ) {
    deleteRef();
  }
}

// copy constructor
SIDL::Loader::Loader ( const ::SIDL::Loader& original ) {
  d_self = const_cast< ior_t*>(original.d_self);
  d_weak_reference = original.d_weak_reference;
  if (d_self != 0 ) {
    addRef();
  }
}

// assignment operator
::SIDL::Loader&
SIDL::Loader::operator=( const ::SIDL::Loader& rhs ) {
  if ( d_self != rhs.d_self ) {
    if ( d_self != 0 ) {
      deleteRef();
    }
    d_self = const_cast< ior_t*>(rhs.d_self);
    d_weak_reference = rhs.d_weak_reference;
    if ( d_self != 0 ) {
      addRef();
    }
  }
  return *this;
}

// conversion from ior to C++ class
SIDL::Loader::Loader ( ::SIDL::Loader::ior_t* ior ) 
    : d_self( ior ), d_weak_reference(false) {
  if ( d_self != 0 ) {
    addRef();
  }
}

// Alternate constructor: does not call addRef()
// (sets d_weak_reference=isWeak)
// For internal use by Impls (fixes bug#275)
SIDL::Loader::Loader ( ::SIDL::Loader::ior_t* ior, bool isWeak ) 
    : d_self( ior ), d_weak_reference(isWeak) { 
}

// conversion from a StubBase
SIDL::Loader::Loader ( const ::SIDL::StubBase& base )
{
  d_self = reinterpret_cast< ior_t*>(base._cast("SIDL.Loader"));
  d_weak_reference = false;
  if (d_self != 0) {
    addRef();
  }
}

// protected method that implements casting
void* SIDL::Loader::_cast(const char* type) const
{
  void* ptr = 0;
  if ( d_self != 0 ) {
    ptr = reinterpret_cast< void*>((*d_self->d_epv->f__cast)(d_self, type));
  }
  return ptr;
}

// Static data type
const ::SIDL::Loader::ext_t * SIDL::Loader::s_ext;

// private static method to get static data type
const ::SIDL::Loader::ext_t *
SIDL::Loader::_get_ext()
  throw (::SIDL::NullIORException)
{
  if (! s_ext ) {
    s_ext = SIDL_Loader__externals();
  }
  return s_ext;
}

